//rww - based on a model/animation format i started years ago, with modern and now quake elements
//tossed in, i adapted much of it to use existing quake math functions as well while i was converting
//it from c++. it's all kind of unpretty.

#ifdef SERVERONLY
	#include "../server/qwsvdef.h"
#else
	#include "quakedef.h"
#endif

#include "gl_modrdm.h"

#ifndef SERVERONLY
typedef struct edictModel_s
{
	int				frame;
	int				oldFrame;
	double			lerpAnimTime;
	safeModelPtr_t	*model;
} edictModel_t;
static edictModel_t g_edictModels[MAX_EDICTS];

float g_lodHackDist = 768.0f;
extern int normalmap_default;
extern qboolean g_depthPass;
extern qboolean g_bloomin;
extern void GL_CreateTangentMatrices(int numVerts, modelVert_t *verts, int numFaces, modelTriFace_t *faces,
											  modelTan_t *argTangentData, modelTexCoord_t *coords, float *vertNormals);
extern void GL_CalcModelLightVectors(int numVerts, modelTan_t *tangents, float *batchVerts,
							  float *lightVectors, float *vertNormals, dlight_t *dlight,
							  entity_t *e, int posenum, qboolean backwards);
extern void GL_GenerateShadowVolume(float objRadius, dlight_t *light, qboolean lightInObject, int *checkVerts,
							int *checkTris, int numVerts, int numTris, float *verts, int *tris,
							modelTriNeighbor_t *neighbors, modelVert_t *vertsOut, int *trisOut,
							float *minsOut, float *maxsOut);
#endif

#define rcmalloc(a, b) malloc(a)
#define rcfree free
#define assert(x)

float g_deformTime = 0.0f;

modelMatrix_t g_identityMatrix =
{
	{1.0f, 0.0f, 0.0f},
	{0.0f, 1.0f, 0.0f},
	{0.0f, 0.0f, 1.0f},
	{0.0f, 0.0f, 0.0f}
};
float g_zeroPoint[3] = {0.0f, 0.0f, 0.0f};

typedef struct modelBinaryStorage_s
{
	char		*filename;
	BYTE		*data;
	int			dataLen;
	qboolean	inuse;
} modelBinaryStorage_t;
#define MAX_MODEL_BINSTORAGE_SIZE 128
static modelBinaryStorage_t g_modelBin[MAX_MODEL_BINSTORAGE_SIZE];

typedef struct modelContainer_s
{
	modelFile_t		*model;
	char			*filename;
	qboolean		inuse;
	int				deferredFrom;
} modelContainer_t;

#define MAX_MODEL_POOL_SIZE 512
static modelContainer_t g_modelPool[MAX_MODEL_POOL_SIZE];
safeModelPtr_t g_modelSafePtrs[MAX_MODEL_POOL_SIZE];

//inline hack. find some precision hack to make this faster or something.
static __inline void Model_FastVecScale(float *v, float scale)
{
	v[0] *= scale;
	v[1] *= scale;
	v[2] *= scale;
}

//silly hackery because i don't have a real texture shader system in quake
void Model_TexNameFilter(modelMeshObject_t *obj, char *texName)
{
	//preliminary pinky tests
	if (strstr(texName, "teeth"))
	{
		obj->alphaMask = true;
	}
	else if (strstr(texName, "gob") || strstr(texName, "film"))
	{
		obj->transparent = true;
	}

	//other stuff
	if (strstr(texName, "leafs"))
	{
		obj->alphaMask = true;
	}
}

//multiply a matrix by another matrix into out (for model format matrix)
static __inline void Model_MatrixMultiply(modelMatrix_t *in, modelMatrix_t *in2, modelMatrix_t *out)
{
	out->x1[0] = (in->x1[0]*in2->x1[0]) + (in->x1[1]*in2->x2[0]) + (in->x1[2]*in2->x3[0]);
	out->x1[1] = (in->x1[0]*in2->x1[1]) + (in->x1[1]*in2->x2[1]) + (in->x1[2]*in2->x3[1]);
	out->x1[2] = (in->x1[0]*in2->x1[2]) + (in->x1[1]*in2->x2[2]) + (in->x1[2]*in2->x3[2]);
	out->o[0] = (in->x1[0]*in2->o[0]) + (in->x1[1]*in2->o[1]) + (in->x1[2]*in2->o[2]) + in->o[0];

	out->x2[0] = (in->x2[0]*in2->x1[0]) + (in->x2[1]*in2->x2[0]) + (in->x2[2]*in2->x3[0]);
	out->x2[1] = (in->x2[0]*in2->x1[1]) + (in->x2[1]*in2->x2[1]) + (in->x2[2]*in2->x3[1]);
	out->x2[2] = (in->x2[0]*in2->x1[2]) + (in->x2[1]*in2->x2[2]) + (in->x2[2]*in2->x3[2]);
	out->o[1] = (in->x2[0]*in2->o[0]) + (in->x2[1]*in2->o[1]) + (in->x2[2]*in2->o[2]) + in->o[1];

	out->x3[0] = (in->x3[0]*in2->x1[0]) + (in->x3[1]*in2->x2[0]) + (in->x3[2]*in2->x3[0]);
	out->x3[1] = (in->x3[0]*in2->x1[1]) + (in->x3[1]*in2->x2[1]) + (in->x3[2]*in2->x3[1]);
	out->x3[2] = (in->x3[0]*in2->x1[2]) + (in->x3[1]*in2->x2[2]) + (in->x3[2]*in2->x3[2]);
	out->o[2] = (in->x3[0]*in2->o[0]) + (in->x3[1]*in2->o[1]) + (in->x3[2]*in2->o[2]) + in->o[2];
}

//transform a point by a given matrix (model format)
static __inline void Model_TransformPointByMatrix(modelMatrix_t *matrix, float *in, float *out)
{
	out[0] = matrix->x1[0]*in[0] + matrix->x1[1]*in[1] + matrix->x1[2]*in[2] + matrix->o[0];
	out[1] = matrix->x2[0]*in[0] + matrix->x2[1]*in[1] + matrix->x2[2]*in[2] + matrix->o[1];
	out[2] = matrix->x3[0]*in[0] + matrix->x3[1]*in[1] + matrix->x3[2]*in[2] + matrix->o[2];
}

//transform a point by a given matrix, don't translate (model format)
static __inline void Model_TransformPointByMatrixNoTrans(modelMatrix_t *matrix, float *in, float *out)
{
	out[0] = matrix->x1[0]*in[0] + matrix->x1[1]*in[1] + matrix->x1[2]*in[2];
	out[1] = matrix->x2[0]*in[0] + matrix->x2[1]*in[1] + matrix->x2[2]*in[2];
	out[2] = matrix->x3[0]*in[0] + matrix->x3[1]*in[1] + matrix->x3[2]*in[2];
}

//get matrix inverse
static __inline void Model_MatrixInverse(modelMatrix_t *in, modelMatrix_t *out)
{
	int i, j;
	float *fIn = (float *)in;
	float *fOut = (float *)out;
	float *dstMat;
	float *srcMat;

    for (i = 0; i < 3; i++)
	{
		dstMat = &fOut[i*3];
        for (j = 0; j < 3; j++)
		{
			srcMat = &fIn[j*3];
            dstMat[j] = srcMat[i];
		}
	}
    for (i = 0; i < 3; i++)
	{
		dstMat = &fOut[i*3];

		out->o[i] = 0.0f;
        for (j = 0; j < 3; j++)
		{
			out->o[i] -= (dstMat[j]*in->o[j]);
		}
	}
}

//calculate all of our vertex normals as soon as we need them.
void Model_GenerateVertexNormals(float *normals, int numVerts, modelVert_t *verts, int numFaces, modelRDMTriFace_t *faces)
{
	int i = 0;
	int j;
	modelVert_t *vert = verts;
	modelRDMTriFace_t *face;
	float *normal = normals;

	while (i < numVerts)
	{
		normal[0] = 0.0f;
		normal[1] = 0.0f;
		normal[2] = 0.0f;
		j = 0;
		face = faces;
		while (j < numFaces)
		{
			modelVert_t *v1, *v2, *v3;
			v1 = (verts+face->a);
			v2 = (verts+face->b);
			v3 = (verts+face->c);

			if (vert == v1 ||
				vert == v2 ||
				vert == v3)
			{ //this vert is attached to this face, so add its plane into the will-be average
				float planeEq[4];

				PlaneEquation(&v1->x, &v2->x, &v3->x, planeEq);
				VectorNormalize(planeEq);
				VectorAdd(normal, planeEq, normal);
			}

			face++;
			j++;
		}
		VectorNormalize(normal);

		normal += 3;
		vert++;
		i++;
	}
}

//make sure plane equations are calculated no more than once per frame
void Model_CreateTriPlanes(modelMeshObject_t *obj, qboolean animating)
{
	int i;

	if (!obj->meshData.mid.triPlaneEq)
	{
		return;
	}
	if (!animating && obj->meshData.mid.triPlDataCalculated &&
		!obj->meshData.mid.triPlWasAnimating)
	{ //if no animation given, assume it is static
		return;
	}
	if (obj->meshData.mid.triPlDataCalculated &&
		obj->meshData.mid.triPlDataCalculatedTime &&
		obj->meshData.mid.triPlDataCalculatedTime == realtime)
	{
		return;
	}

	obj->meshData.mid.triPlWasAnimating = animating;
	obj->meshData.mid.triPlDataCalculated = true;
	obj->meshData.mid.triPlDataCalculatedTime = realtime;

	for (i = 0; i < obj->meshData.numFaces; i++)
	{
		triPlaneEq_t *planeEq = obj->meshData.mid.triPlaneEq+i;
		modelRDMTriFace_t *face = ((modelRDMTriFace_t *)obj->meshData.faceData)+i;
		modelVert_t *v1 = obj->meshData.mid.vertDataTransformed+face->a;
		modelVert_t *v2 = obj->meshData.mid.vertDataTransformed+face->b;
		modelVert_t *v3 = obj->meshData.mid.vertDataTransformed+face->c;
        
		PlaneEquation((float *)v1, (float *)v2, (float *)v3, (float *)planeEq);
	}
}

//find an object given a hierarchy position
static modelMeshObject_t *Model_FindObjectForHierarchalIndex(modelFile_t *model, WORD index)
{
	modelMeshObject_t *n = model->firstObject;
	while (n)
	{
		if (n->hierarchyPos == index)
		{
			return n;
		}
		n = n->next;
	}

	return NULL;
}

//fill in parent pointers for quick access while checking for matrix overrides
static void Model_FillParentPtrs(modelFile_t *model)
{
	modelMeshObject_t *n = model->firstObject;
	while (n)
	{
		if (n->hierarchy)
		{
			n->parent = Model_FindObjectForHierarchalIndex(model, n->hierarchy->father);
		}
		n = n->next;
	}
}

//calculate object mins/maxs
static void Model_SetObjectMinsMaxs(modelMeshObject_t *obj)
{
	int numVerts = obj->meshData.numVerts;
	modelVert_t *verts = (modelVert_t *)(obj->meshData.vertData);
	int i = 0;
	int j = 0;

	VectorCopy((&verts->x), obj->mins);
	VectorCopy((&verts->x), obj->maxs);

	while (i < numVerts)
	{
		float *vertF = &verts->x;

		j = 0;
		while (j < 3)
		{
			if (*vertF < obj->mins[j])
			{
				obj->mins[j] = *vertF;
			}
			if (*vertF > obj->maxs[j])
			{
				obj->maxs[j] = *vertF;
			}

			j++;
			vertF++;
		}

		verts++;
		i++;
	}
}

//calculate bounding boxes for each object for faster per-triangle collision detection
static void Model_SetAllObjectsMinsMaxs(modelFile_t *model)
{
	qboolean gotB = false;
	modelMeshObject_t *root = model->firstObject;
	modelMeshObject_t *n = model->firstObject;
	while (n)
	{
		if (n->meshData.vertData)
		{
			int numVerts = n->meshData.numVerts;
			modelVert_t *verts = (modelVert_t *)(n->meshData.vertData);
			int i = 0;
			int j = 0;

			if (!gotB)
			{
				VectorCopy((&verts->x), root->mins);
				VectorCopy((&verts->x), root->maxs);
				gotB = true;
			}

			while (i < numVerts)
			{
				float *vertF = &verts->x;

				j = 0;
				while (j < 3)
				{
					if (*vertF < root->mins[j])
					{
						root->mins[j] = *vertF;
					}
					if (*vertF > root->maxs[j])
					{
						root->maxs[j] = *vertF;
					}

					j++;
					vertF++;
				}

				verts++;
				i++;
			}
		}
		n = n->next;
	}
}

//find an object in the model by name
modelMeshObject_t *Model_GetObjectByName(const char *objName, modelFile_t *model)
{
	modelMeshObject_t *n = model->firstObject;
	while (n)
	{
		if (n->objName &&
			!strcmp(objName, n->objName))
		{
			return n;
		}
		n = n->next;
	}
	return NULL;
}

//find a bone by a given name
modelBone_t *Model_FindObjectBoneByName(modelMeshObject_t *obj, const char *boneName)
{
	modelBone_t *b = obj->meshData.bones;
	int i = 0;

	while (i < obj->meshData.numBones)
	{
		if (!stricmp(boneName, b->name))
		{
			return b;
		}

		b++;
		i++;
	}

	return NULL;
}

//get the matrix for the given frame on a bone
void Model_FrameMatrixForBoneAnim(modelBone_t *bone, rdaBone_t *boneAnim, int frame, modelMatrix_t *out)
{
	modelMatrix_t baseMat;
	modelMatrix_t boneMat;
	float transXYZ[3];

	//we need to use the parent's matrix as our base, since offsets
	//are stored additively. if no parent, identity will do.
	if (bone->eData.parent)
	{ //todo: check if modifyMat is non-identity to avoid needless matrix mults
		baseMat = bone->eData.parent->eData.finalMat;
		//Model_MatrixMultiply(&bone->eData.parent->eData.parentMat, &bone->eData.modifyMat, &baseMat);
	}
	else
	{
		//baseMat = bone->eData.modifyMat;
		baseMat = g_identityMatrix;
	}

	boneMat = *(boneAnim->mat+frame);
	Model_TransformPointByMatrixNoTrans(&baseMat, boneMat.o, transXYZ);
	VectorAdd(baseMat.o, transXYZ, baseMat.o);

	boneMat.o[0] = 0.0f;
	boneMat.o[1] = 0.0f;
	boneMat.o[2] = 0.0f;

	Model_MatrixMultiply(&baseMat, &boneMat, out);
}

//set an override matrix
//note that it's possible for different meshes on the same model to override the same
//bone using different matrices.
void Model_SetOverrideMatrix(modelMeshObject_t *mesh, modelBone_t *bone, modelMatrix_t *mat)
{
	boneOverrides_t *bo;
	int boneIndex;
	if (!mesh->meshData.mid.boneOverrides)
	{
		int i;
		size_t s = sizeof(boneOverrides_t)*mesh->meshData.numBones;
		mesh->meshData.mid.boneOverrides = (boneOverrides_t *)rcmalloc(s, 99);
		memset(mesh->meshData.mid.boneOverrides, 0, s);
		for (i = 0; i < mesh->meshData.numBones; i++)
		{
			bo = mesh->meshData.mid.boneOverrides+i;
			bo->modifyMat = g_identityMatrix;
		}
	}

	bo = mesh->meshData.mid.boneOverrides;
	if (!bo)
	{
		return;
	}

	boneIndex = bone-mesh->meshData.bones;
	(bo+boneIndex)->modifyMat = *mat;
	mesh->meshData.mid.bonesModified = true;
}

//just the parent matrix, unless we have overrides
void Model_GetOverrideMat(modelMeshObject_t *obj, modelBone_t *bone)
{
	int boneIndex;
	boneOverrides_t *bo = obj->meshData.mid.boneOverrides;
	if (!bo)
	{
		if (bone->eData.parent)
		{
			bone->eData.parentMat = bone->eData.parent->eData.parentMat;
		}
		else
		{
			bone->eData.parentMat = g_identityMatrix;
		}
		return;
	}

	boneIndex = bone-obj->meshData.bones;
	if (bone->eData.parent)
	{
		Model_MatrixMultiply(&bone->eData.parent->eData.parentMat, &(bo+boneIndex)->modifyMat, &bone->eData.parentMat);
	}
	else
	{
		bone->eData.parentMat = (bo+boneIndex)->modifyMat;
	}
}

//transform a bone, making sure its parent is transformed as well.
void Model_TransformBone(modelMeshObject_t *obj, modelBone_t *bone, rda_t *anim, int frame, int oldFrame,
						 float lerpAmt, double timeCheck)
{
	rdaBone_t *animBone;
	modelMatrix_t matCur, matLast;

	if (bone->eData.parent)
	{ //make sure parent is transformed first.
		Model_TransformBone(obj, bone->eData.parent, anim, frame, oldFrame, lerpAmt, timeCheck);
	}

//	if (bone->eData.transformTime == timeCheck && timeCheck > 0)
//	{ //already transformed
//		return;
//	}

	bone->eData.transformTime = timeCheck;

	if (!anim)
	{
		Model_GetOverrideMat(obj, bone);
		Model_MatrixMultiply(&bone->eData.parentMat, &bone->mat, &bone->eData.finalMat);
		//bone->eData.finalMat = bone->eData.parentMat;
		return;
	}

	animBone = anim->bones+bone->index;

	assert(animBone->index == bone->index);

	//make sure frame and oldFrame are within range
	if (frame >= anim->hdr.numFrames)
	{
		frame = anim->hdr.numFrames-1;
	}
	if (frame < 0)
	{
		frame = 0;
	}
	if (oldFrame >= anim->hdr.numFrames)
	{
		oldFrame = anim->hdr.numFrames-1;
	}
	if (oldFrame < 0)
	{
		oldFrame = 0;
	}

	//lets get the matrices for the current frame and last frame
	Model_FrameMatrixForBoneAnim(bone, animBone, frame, &matCur);
	Model_FrameMatrixForBoneAnim(bone, animBone, oldFrame, &matLast);

	//now, lets lerp between them.
	if (!lerpAmt)
	{ //looks like it's totally up to date, so don't lerp at all
		bone->eData.finalMat = matCur;
	}
	else
	{
		modelMatrix_t m;
		float lerpFrac = 1.0f-lerpAmt;

		bone->eData.finalMat = matLast;

		VectorSubtract(matCur.x1, matLast.x1, m.x1);
		VectorSubtract(matCur.x2, matLast.x2, m.x2);
		VectorSubtract(matCur.x3, matLast.x3, m.x3);
		VectorSubtract(matCur.o, matLast.o, m.o);

		Model_FastVecScale(m.x1, lerpFrac);
		VectorAdd(bone->eData.finalMat.x1, m.x1, bone->eData.finalMat.x1);

		Model_FastVecScale(m.x2, lerpFrac);
		VectorAdd(bone->eData.finalMat.x2, m.x2, bone->eData.finalMat.x2);

		Model_FastVecScale(m.x3, lerpFrac);
		VectorAdd(bone->eData.finalMat.x3, m.x3, bone->eData.finalMat.x3);

		Model_FastVecScale(m.o, lerpFrac);
		VectorAdd(bone->eData.finalMat.o, m.o, bone->eData.finalMat.o);
	}

	//create the local matrix for normal transforms
	Model_MatrixMultiply(&bone->eData.finalMat, &bone->eData.invBaseMat, &bone->eData.localMat);
}

//make sure all bones are transformed.
void Model_TransformBones(modelMeshObject_t *obj, rda_t *anim, int frame, int oldFrame,
						 float lerpAmt, double timeCheck)
{
	modelBone_t *b = obj->meshData.bones;
	int numB = 0;
	while (numB < obj->meshData.numBones)
	{ //transform the bones first
		Model_TransformBone(obj, b, anim, frame, oldFrame, lerpAmt, timeCheck);

		b++;
		numB++;
	}
}

//create transformed vertex array
void Model_CreateTransformedVerts(modelParmData_t *sceneObj, modelMeshObject_t *obj, qboolean doTrans, double colTrans)
{
	double timeCheck = realtime;
	modelVertWInfo_t *vWInfo;
	qboolean animating;
	qboolean sameScale;
	qboolean gotAnyBounds;
	qboolean hasScale = false;
	int i, j;
	//modelMatrix_t transformMatrix;
	modelVert_t *verts;
	modelVert_t *tVerts;
	modelVert_t *transNormals;
	modelVert_t *firstNormals;

	if (colTrans)
	{
		timeCheck = colTrans;
	}

	if (!obj->meshData.mid.vertDataTransformed)
	{ //allocate space now if needed
		obj->meshData.mid.vertDataTransformed = (modelVert_t *)rcmalloc(obj->meshData.numVerts*sizeof(modelVert_t), 11);
	}
	else if (obj->meshData.mid.vertDataTransformedTime &&
		obj->meshData.mid.vertDataDataCalculated &&
		obj->meshData.mid.vertDataTransformedTime == timeCheck &&
		(!sceneObj || obj->meshData.mid.vertDataLastDeform == sceneObj->deforms))
	{ //already done this frame
		return;
	}

	animating = false;
	sameScale = false;
	if (sceneObj &&
		(sceneObj->anim || ( (sceneObj->deforms & DEFORM_MDLPULSE) || (sceneObj->deforms & DEFORM_MDLPLANESCALE) )))
	{
		animating = true;
	}
	if (sceneObj &&
		obj->meshData.mid.vertDataLastScale[0] == sceneObj->modelScale[0] &&
		obj->meshData.mid.vertDataLastScale[1] == sceneObj->modelScale[1] &&
		obj->meshData.mid.vertDataLastScale[2] == sceneObj->modelScale[2])
	{
		sameScale = true;
	}
	if (!animating && obj->meshData.mid.vertDataDataCalculated &&
		!obj->meshData.mid.vertDataWasAnimating &&
		sameScale && doTrans &&
		(!sceneObj || obj->meshData.mid.vertDataLastDeform == sceneObj->deforms) &&
		!obj->meshData.mid.bonesModified)
	{ //if no animation given, assume it is static
		return;
	}

	if (sceneObj)
	{
		obj->meshData.mid.vertDataLastDeform = sceneObj->deforms;
	}
	else
	{
		obj->meshData.mid.vertDataLastDeform = 0;
	}

	obj->meshData.mid.vertDataWasAnimating = animating;
	obj->meshData.mid.vertDataDataCalculated = true;
	obj->meshData.mid.vertDataTransformedTime = timeCheck;
	if (sceneObj && !sameScale)
	{
		obj->meshData.mid.vertDataLastScale[0] = sceneObj->modelScale[0];
		obj->meshData.mid.vertDataLastScale[1] = sceneObj->modelScale[1];
		obj->meshData.mid.vertDataLastScale[2] = sceneObj->modelScale[2];
	}

    if (!doTrans)
	{
		memcpy(obj->meshData.mid.vertDataTransformed, obj->meshData.vertData, obj->meshData.numVerts*sizeof(modelVert_t));
		return;
	}

	i = 0;
	verts = (modelVert_t *)obj->meshData.vertData;
	tVerts = obj->meshData.mid.vertDataTransformed;

	//transformMatrix = obj->curMatrix;
	if (sceneObj)
	{
		if (sceneObj->modelScale[0] != 0.0f ||
			sceneObj->modelScale[1] != 0.0f ||
			sceneObj->modelScale[2] != 0.0f)
		{
			/*
			Model_FastVecScale(transformMatrix.x1, sceneObj->modelScale[0]);
			Model_FastVecScale(transformMatrix.x2, sceneObj->modelScale[1]);
			Model_FastVecScale(transformMatrix.x3, sceneObj->modelScale[2]);
			*/
			hasScale = true;
		}
	}

	vWInfo = (modelVertWInfo_t *)obj->meshData.vertWInfo;

	if (sceneObj)
	{
		Model_TransformBones(obj, sceneObj->anim, sceneObj->frame, sceneObj->oldFrame, sceneObj->frameLerp, timeCheck);
	}
	else
	{
		Model_TransformBones(obj, NULL, 0, 0, 0.0f, timeCheck);
	}
	obj->meshData.mid.bonesModified = false;

	if (vWInfo && obj->meshData.vertNormals)
	{ //a weighted boned object, so...
		if (!obj->meshData.mid.vertNormalsTransformed && animating)
		{
			obj->meshData.mid.vertNormalsTransformed = (float *)rcmalloc(sizeof(modelVert_t)*obj->meshData.numVerts, 11);
			memcpy(obj->meshData.mid.vertNormalsTransformed, obj->meshData.vertNormals, sizeof(modelVert_t)*obj->meshData.numVerts);
		}
	}

	transNormals = (modelVert_t *)obj->meshData.mid.vertNormalsTransformed;
	firstNormals = (modelVert_t *)obj->meshData.vertNormals;

	//if it's not animating, just make sure the transformed normals are the base pose normals
	//FIXME: don't actually need to copy this every frame, just once unless toggling animation again
	if (transNormals)
	{
		if (!animating)
		{ //not animating, don't transform normals.
			//memcpy(transNormals, firstNormals, sizeof(modelVert_t)*obj->meshData.numVerts);
			if (obj->meshData.mid.vertNormalsTransformed)
			{
				rcfree(obj->meshData.mid.vertNormalsTransformed);
				obj->meshData.mid.vertNormalsTransformed = NULL;
			}
			transNormals = NULL;
		}
	}
	gotAnyBounds = false;
	while (i < obj->meshData.numVerts)
	{
		//float v[3];
		float *v = &tVerts->x;

		if (vWInfo)
		{ //lets do the transform then.
			int w = 0;
			v[0] = 0.0f;
			v[1] = 0.0f;
			v[2] = 0.0f;
			if (transNormals)
			{
				transNormals->x = 0.0f;
				transNormals->y = 0.0f;
				transNormals->z = 0.0f;
			}

			while (w < vWInfo->numWeights)
			{
				modelVertWeight_t *weight;
				modelBone_t *weightedBone;
				float p[3];
				modelMatrix_t *transMat;

				weight = obj->meshData.vertWeights+(vWInfo->weightIndex+w);
				weightedBone = obj->meshData.bones+weight->boneIndex;

				assert(weightedBone && weightedBone->index == weight->boneIndex && weight->index == (vWInfo->weightIndex+w));

				transMat = &weightedBone->eData.finalMat;

				//Model_TransformPointByMatrix(transMat, weight->pos, p);
				//Model_FastVecScale(p, weight->weightFactor);
				//VectorAdd(v, p, v);
				p[0] = transMat->x1[0]*weight->pos[0] + transMat->x1[1]*weight->pos[1] + transMat->x1[2]*weight->pos[2] + transMat->o[0];
				p[1] = transMat->x2[0]*weight->pos[0] + transMat->x2[1]*weight->pos[1] + transMat->x2[2]*weight->pos[2] + transMat->o[1];
				p[2] = transMat->x3[0]*weight->pos[0] + transMat->x3[1]*weight->pos[1] + transMat->x3[2]*weight->pos[2] + transMat->o[2];
				v[0] += p[0]*weight->weightFactor;
				v[1] += p[1]*weight->weightFactor;
				v[2] += p[2]*weight->weightFactor;

				if (transNormals)
				{
					Model_TransformPointByMatrixNoTrans(&weightedBone->eData.localMat, (float *)firstNormals, (float *)transNormals);
				}

				w++;
			}

			if (transNormals)
			{
				VectorNormalize((float *)transNormals);

				transNormals++;
				firstNormals++;
			}

			vWInfo++;
		}
		else
		{
			VectorCopy(((float *)verts), v);
		}

		if (hasScale)
		{
			v[0] *= sceneObj->modelScale[0];
			v[1] *= sceneObj->modelScale[1];
			v[2] *= sceneObj->modelScale[2];
		}

		//Model_TransformPointByMatrix(&transformMatrix, v, &tVerts->x);
		//=====================
#if 0
		if (!gotAnyBounds)
		{
			obj->meshData.mid.transObjMins[0] = v[0]-1.0f;
			obj->meshData.mid.transObjMins[1] = v[1]-1.0f;
			obj->meshData.mid.transObjMins[2] = v[2]-1.0f;
			obj->meshData.mid.transObjMaxs[0] = v[0]+1.0f;
			obj->meshData.mid.transObjMaxs[1] = v[1]+1.0f;
			obj->meshData.mid.transObjMaxs[2] = v[2]+1.0f;
			gotAnyBounds = true;
		}
		for (j = 0; j < 3; j++)
		{
			if (v[j] < obj->meshData.mid.transObjMins[j])
			{
				obj->meshData.mid.transObjMins[j] = v[j];
			}
			if (v[j] > obj->meshData.mid.transObjMaxs[j])
			{
				obj->meshData.mid.transObjMaxs[j] = v[j];
			}
		}
#endif
		//=====================
		verts++;
		tVerts++;
		i++;
	}

#if 0
	for (j = 0; j < 3; j++)
	{
		obj->meshData.mid.transObjMins[j] -= 1.0f;
		obj->meshData.mid.transObjMaxs[j] += 1.0f;
	}
#endif

	if (sceneObj && ( (sceneObj->deforms & DEFORM_MDLPULSE) || (sceneObj->deforms & DEFORM_MDLPLANESCALE) ))
	{ //model deformation
		modelVert_t *normals;
		if (obj->meshData.mid.vertNormalsTransformed)
		{
			normals = (modelVert_t *)obj->meshData.mid.vertNormalsTransformed;
		}
		else
		{
			normals = (modelVert_t *)obj->meshData.vertNormals;
		}
		if (normals)
		{
			float timeFact = g_deformTime*sceneObj->deformPropB;

			tVerts = obj->meshData.mid.vertDataTransformed;
			i = 0;
			while (i < obj->meshData.numVerts)
			{
				float n[3];

				if (sceneObj->deforms & DEFORM_MDLPULSE)
				{
					n[0] = normals->x*(sceneObj->deformPropA+(sinf((float)i+(float)timeFact)*sceneObj->deformPropA));
					n[1] = normals->y*(sceneObj->deformPropA+(sinf((float)i+(float)timeFact)*sceneObj->deformPropA));
					n[2] = normals->z*(sceneObj->deformPropA+(sinf((float)i+(float)timeFact)*sceneObj->deformPropA));
				}
				else
				{
					n[0] = normals->x*sceneObj->deformPropA;
					n[1] = normals->y*sceneObj->deformPropA;
					n[2] = normals->z*sceneObj->deformPropA;
				}

				VectorAdd((&tVerts->x), n, (&tVerts->x));

				tVerts++;
				normals++;
				i++;
			}
		}
	}
}

//create formatted face data
void Model_CreateFormattedFaces(modelMeshObject_t *obj)
{
	int x;
	modelTriFaceGLFormat_t *faceForm;
	modelRDMTriFace_t *face;

	if (!obj->meshData.faceDataFormatted)
	{ //a one-time cost.
		obj->meshData.faceDataFormatted = (modelTriFaceGLFormat_t *)rcmalloc(obj->meshData.numFaces*sizeof(modelTriFaceGLFormat_t), 11);
	}
	x = 0;
	faceForm = obj->meshData.faceDataFormatted;
	face = (modelRDMTriFace_t *)obj->meshData.faceData;
	while (x < obj->meshData.numFaces)
	{
		faceForm->a = face->a;
		faceForm->b = face->b;
		faceForm->c = face->c;

		assert(faceForm->a >= 0 && faceForm->a < obj->meshData.numVerts);
		assert(faceForm->b >= 0 && faceForm->b < obj->meshData.numVerts);
		assert(faceForm->c >= 0 && faceForm->c < obj->meshData.numVerts);

		faceForm++;
		face++;
		x++;
	}
}

//set render visibility
void Model_ToggleRender(modelFile_t *model, const char *objName, qboolean visible)
{
	modelMeshObject_t *n = Model_GetObjectByName(objName, model);

	if (!n)
	{
		return;
	}

	//got it, toggle enabled flag.
	if (visible)
	{
		n->flags &= ~OBJFLAG_DISABLE_SURFACE;
	}
	else
	{
		n->flags |= OBJFLAG_DISABLE_SURFACE;
	}
}

//set render visibility on all surfs
void Model_ToggleRenderAllSurfs(modelFile_t *model, qboolean visible)
{
	modelMeshObject_t *n = model->firstObject;

	while (n)
	{
		//got it, toggle enabled flag.
		if (visible)
		{
			n->flags &= ~OBJFLAG_DISABLE_SURFACE;
		}
		else
		{
			n->flags |= OBJFLAG_DISABLE_SURFACE;
		}
		n = n->next;
	}
}

//override the transformation matrix
void Model_MatrixOverride(modelFile_t *model, const char *objName, modelMatrix_t *matrix)
{
	modelMeshObject_t *n = Model_GetObjectByName(objName, model);

	if (!n)
	{
		return;
	}

	if (!matrix)
	{ //then make sure we are not using an override matrix
		n->flags &= ~OBJFLAG_OVERRIDE_MATRIX;
	}
	else
	{ //ok, flag it and copy the matrix in
		n->flags |= OBJFLAG_OVERRIDE_MATRIX;
		memcpy(&n->overrideMatrix, matrix, sizeof(n->overrideMatrix));
	}
}

//get triangle neighbors for a given tri
void Model_GetTriNeighbors(modelMeshObject_t *modelObj, modelTriFaceGLFormat_t *tris, modelTriFaceGLFormat_t *tri, int *neighbors)
{
	int *n;
	int *triInt = (int *)tri;
	int i = 0;
	int numN = 0;
	int j, k;
	int vertA1, vertA2, vertB1, vertB2;

	neighbors[0] = neighbors[1] = neighbors[2] = -1;

	while (i < modelObj->meshData.numFaces)
	{
		n = (int *)&tris[i];

		if (n != triInt)
		{
			j = 0;
			while (j < 3)
			{
				vertA1 = triInt[j];
				vertA2 = triInt[(j+1)%3];

				k = 0;
				while (k < 3)
				{
					vertB1 = n[k];
					vertB2 = n[(k+1)%3];

					if ((vertA1 == vertB1 && vertA2 == vertB2) || (vertA1 == vertB2 && vertA2 == vertB1))
					{
						if (neighbors[j] == -1)
						{
							neighbors[j] = i;
						}
						else
						{ //this edge is shared by more than 2 tris apparently.
						  //this seems to actually happen at times, which is why
						  //we are bothering to check for it.
							neighbors[j] = -2;
						}
					}

					k++;
				}

				j++;
			}
		}

		i++;
	}

	j = 0;
	while (j < 3)
	{ //mark any -2 as -1 now since we're done
		if (neighbors[j] == -2)
		{
			neighbors[j] = -1;
		}
		j++;
	}
}

chunkTable_t g_chunkTable3DS = {
	0x4D4D,			//chunkMain;
	0x0002,			//chunkVersion;
	0x3D3D,			//chunk3DEdit;
	0x4000,			//chunkObject;
	0x4100,			//chunkObjectTriMesh;
	0x4110,			//chunkObjectVertData;
	0x4120,			//chunkObjectFaceData;
	0x4130,			//chunkObjectFaceMatData;
	0x4140,			//chunkObjectTexCoords;
	0x4150,			//chunkObjectSmoothGrp;
	0x4160,			//chunkObjectCoordOffset;
	0xB000,			//chunkKeyframer;
	0xB002,			//chunkMeshInfo;
	0xB008,			//chunkStartEndFrames;
	0xB010,			//chunkHierarchy;
	0xB00A,			//chunkKeyframerHeader;
	0xB013,			//chunkPivotPoint;
	0xB020,			//chunkPositionTrack;
	0xB021,			//chunkRotationTrack;
	0xB022,			//chunkScaleTrack;
	0xB024,			//chunkRollTrack;
	0xB030,			//chunkHierarchyPos;

	0x9999,			//chunkObjectVertNormals;
	0x9999,			//chunkObjectVertWeights;
	0x9999,			//chunkObjectVertWInfo;
	0x9999,			//chunkObjectBoneNum;
	0x9999			//chunkObjectBone;
};

chunkTable_t g_chunkTableRDM = {
	0x1000,			//chunkMain;
	0x1002,			//chunkVersion;
	0x0001,			//chunk3DEdit;
	0x2000,			//chunkObject;
	0x2100,			//chunkObjectTriMesh;
	0x2110,			//chunkObjectVertData;
	0x2120,			//chunkObjectFaceData;
	0x2130,			//chunkObjectFaceMatData;
	0x2140,			//chunkObjectTexCoords;
	0x2150,			//chunkObjectSmoothGrp;
	0x2160,			//chunkObjectCoordOffset;
	0x3000,			//chunkKeyframer;
	0x3002,			//chunkMeshInfo;
	0x3008,			//chunkStartEndFrames;
	0x3010,			//chunkHierarchy;
	0x300A,			//chunkKeyframerHeader;
	0x3013,			//chunkPivotPoint;
	0x3020,			//chunkPositionTrack;
	0x3021,			//chunkRotationTrack;
	0x3022,			//chunkScaleTrack;
	0x3024,			//chunkRollTrack;
	0x3030,			//chunkHierarchyPos;

	//below here are chunks specific to my model format (don't exist in 3ds)
	0x2170,			//chunkObjectVertNormals;
	0x2180,			//chunkObjectVertWeights;
	0x2185,			//chunkObjectVertWInfo;
	0x2189,			//chunkObjectBoneNum;
	0x2190			//chunkObjectBone;
};

//got the file buffer, now load it into structural form.
int Model_LoadModelParse(modelFile_t *curFile)
{
	char *s;
	WORD *testHead;
	modelMeshObject_t *meshObj;
	int bufferLen = curFile->fileLen;
	modelMeshObject_t *animObj = NULL;
	modelMeshObject_t **curObject;
	modelAnimTrackFrames_t *animTrackFrames = NULL;
	chunkTable_t *chunkTable = &g_chunkTable3DS;

	//float *fP;
	WORD hierarchyPos = 0;

	int i = 0;

	curObject = &curFile->firstObject;

	testHead = (WORD *)&curFile->fileBuffer[i];
	if (*testHead == 0x1337)
	{ //my model format
		i += sizeof(WORD);
		chunkTable = &g_chunkTableRDM;
	}

	while (i < bufferLen)
	{
		modelChunk_t *chunk = (modelChunk_t *)&curFile->fileBuffer[i];
		if (chunk->len > (DWORD)bufferLen ||
			chunk->len <= 0)
		{ //something is fucked here.
			goto endIt;
		}

		if (chunk->type == chunkTable->chunkMain) //main chunk
		{
			i += ( (sizeof(modelChunk_t)-1) );
		}
		else if (chunk->type == chunkTable->chunkVersion) //version chunk (handle but don't really care)
		{
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunk3DEdit) //3d editor chunk (don't care about specifically but must handle to get to the meat)
		{
			i += ( (sizeof(modelChunk_t)-1) );
		}

		//MAIN OBJECT PARSE BEGIN
		else if (chunk->type == chunkTable->chunkObject) //an object
		{
			modelMeshObject_t *oldObject = *curObject;

			i += ( (sizeof(modelChunk_t)-1) );
			//begin object, parse past name of the object.
			while (*curObject)
			{
				curObject = &(*curObject)->next;
			}
			*curObject = (modelMeshObject_t *)rcmalloc(sizeof(modelMeshObject_t), 11);
			memset(*curObject, 0, sizeof(modelMeshObject_t));
			(*curObject)->objName = (char *)&chunk->data;
			i += (int)strlen((*curObject)->objName)+1;

			if (oldObject && oldObject->meshData.bones)
			{ //inherit them
				(*curObject)->meshData.inheritedBones = true;
				(*curObject)->meshData.bones = oldObject->meshData.bones;
				(*curObject)->meshData.numBones = oldObject->meshData.numBones;
			}
		}
		else if (chunk->type == chunkTable->chunkObjectTriMesh) //triangular mesh (PARENT 4000)
		{
			i += ( (sizeof(modelChunk_t)-1) );
		}
		else if (chunk->type == chunkTable->chunkObjectVertData) //vert data (PARENT 4100)
		{
			(*curObject)->meshData.vertData = (BYTE *)(&chunk->data+(sizeof(WORD)));
			i += ( (sizeof(modelChunk_t)-1) );
			(*curObject)->meshData.numVerts = *((WORD *)&chunk->data);
			i += sizeof(WORD);
			i += ((sizeof(float)*3)*(*curObject)->meshData.numVerts);
		}
		else if (chunk->type == chunkTable->chunkObjectFaceData) //face data (PARENT 4100)
		{
			(*curObject)->meshData.faceData = (BYTE *)(&chunk->data+(sizeof(WORD)));
			i += ( (sizeof(modelChunk_t)-1) );
			(*curObject)->meshData.numFaces = *((WORD *)&chunk->data);
			i += sizeof(WORD);
			i += ((sizeof(WORD)*4)*(*curObject)->meshData.numFaces);
		}
		else if (chunk->type == chunkTable->chunkObjectFaceMatData) //face material data (PARENT 4120)
		{
			char *tryTx;
			char realTxName[1024];

			(*curObject)->meshData.faceMatList = &chunk->data;
			tryTx = (char *)&chunk->data;
			/*
			if (!Img_TextureLoad(tryTx, &(*curObject)->objTexture))
			{
				if (!Img_TextureLoad("assets/textures/deftex", &(*curObject)->objTexture))
				{
					(*curObject)->objTexture.inuse = false;
				}
			}
			*/
#ifndef SERVERONLY
			sprintf(realTxName, "qdix/%s.png", tryTx);
			(*curObject)->objTexture = texture_extension_number;
			texture_extension_number++;
			if (!GL_UploadPNG(realTxName, (*curObject)->objTexture, true))
			{
				(*curObject)->objTexture = 0;
				texture_extension_number--;
			}
			else
			{ //try for normal map
				sprintf(realTxName, "qdix/%s_normal.png", tryTx);
				(*curObject)->objTextureNormal = texture_extension_number;
				texture_extension_number++;
				if (!GL_UploadPNG(realTxName, (*curObject)->objTextureNormal, true))
				{
					(*curObject)->objTextureNormal = 0;
					texture_extension_number--;
				}
			}
#endif
			Model_TexNameFilter((*curObject), realTxName);
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectTexCoords) //face texture mapping data (PARENT 4100)
		{
			(*curObject)->meshData.uvCoord = &chunk->data;
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectSmoothGrp) //smoothing groups (PARENT 4120)
		{
			(*curObject)->meshData.smoothingGrp = &chunk->data;
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectCoordOffset) //coordinate offsets (PARENT 4100)
		{
			(*curObject)->meshData.coordOffset = &chunk->data;
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectVertNormals) //vertex normals (RDM only)
		{
			(*curObject)->meshData.vertNormals = (float *)&chunk->data;
			(*curObject)->meshData.vertNormalsStored = true;
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectVertWeights) //vertex weights (RDM only)
		{
			(*curObject)->meshData.numWeights = *((DWORD *)&chunk->data);
			(*curObject)->meshData.vertWeights = (modelVertWeight_t *)(&chunk->data+(sizeof(DWORD)));
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectVertWInfo) //vertex weight correspondance (RDM only)
		{
			(*curObject)->meshData.vertWInfo = (modelVertWInfo_t *)&chunk->data;
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectBoneNum)
		{
			modelMeshObject_t *obj = (*curObject);

			if (obj)
			{
				DWORD *numBones = (DWORD *)&chunk->data;
				obj->meshData.numBones = *numBones;
				assert(!obj->meshData.bones);
				obj->meshData.bones = (modelBone_t *)rcmalloc(sizeof(modelBone_t)*obj->meshData.numBones, 11);
				memset(obj->meshData.bones, 0, sizeof(modelBone_t)*obj->meshData.numBones);
			}
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkObjectBone)
		{
			modelMeshObject_t *obj = (*curObject);

			if (obj && obj->meshData.numBones > 0)
			{
				modelBone_t *src = (modelBone_t *)&chunk->data;
				modelBone_t *dst = obj->meshData.bones+src->index;

				//*dst = *src;
				memcpy(dst, src, sizeof(modelBone_t)-sizeof(modelBoneExData_t));
				memset(&dst->eData, 0, sizeof(modelBoneExData_t));
			}
			i += chunk->len;
		}
		//MAIN OBJECT PARSE END

		//ANIM DATA PARSE BEGIN
		else if (chunk->type == chunkTable->chunkKeyframer) //keyframer chunk
		{
			i += ( (sizeof(modelChunk_t)-1) );
		}
		else if (chunk->type == chunkTable->chunkMeshInfo) //Mesh information block
		{
			i += ( (sizeof(modelChunk_t)-1) );
		}
		else if (chunk->type == chunkTable->chunkStartEndFrames) //start and end frame
		{
			animTrackFrames = (modelAnimTrackFrames_t *)&chunk->data;
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkHierarchy) //hierarchy for a given object (listed in spec as child of B000, but I think actually child of B002)
		{
			s = (char *)&chunk->data;
			animObj = Model_GetObjectByName(s, curFile);

			if (!animObj)
			{ //hmm, must be a dummy object that doesn't exist in the mesh, lets create it so hierarchy can reference it.
				while (*curObject)
				{
					curObject = &(*curObject)->next;
				}
				*curObject = (modelMeshObject_t *)rcmalloc(sizeof(modelMeshObject_t), 11);
				memset(*curObject, 0, sizeof(modelMeshObject_t));
				(*curObject)->objName = s;

				//now we should be able to find it, since we just created it!
				animObj = Model_GetObjectByName(s, curFile);
			}

			if (animObj)
			{ //should always find the object, because the object data should be stored in a chunk before we get to this one.
				animObj->hierarchy = (modelHierData_t *)(&chunk->data+strlen(s)+1);
				animObj->hierarchyPos = hierarchyPos; //in chunk before this
			}
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkKeyframerHeader) //keyframer header...?
		{
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkPivotPoint) //object pivot point
		{
			assert(animObj);
			if (animObj)
			{
				animObj->pivotPoint = (float *)&chunk->data;
			}
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkPositionTrack) //position track
		{
			assert(animObj);
			if (animObj)
			{
				animObj->animTrack_Pos = (modelAnimTrack_Pos_t *)&chunk->data;
			}
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkRotationTrack) //rotation track
		{
			assert(animObj);
			if (animObj)
			{
				animObj->animTrack_Rot = (modelAnimTrack_Rot_t *)&chunk->data;
			}
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkScaleTrack) //scale track
		{
			assert(animObj);
			if (animObj)
			{
				animObj->animTrack_Scale = (modelAnimTrack_Scale_t *)&chunk->data;
			}
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkRollTrack) //roll track
		{
			i += chunk->len;
		}
		else if (chunk->type == chunkTable->chunkHierarchyPos) //object hierarchy position
		{
			hierarchyPos = *((WORD *)&chunk->data);
			i += chunk->len;
		}
		//ANIM DATA PARSE END

		else //don't care about it then.
		{
			i += chunk->len;
		}
	}
endIt:
	Model_FillParentPtrs(curFile);
	Model_SetAllObjectsMinsMaxs(curFile);

	meshObj = curFile->firstObject;
	while (meshObj)
	{
		modelBone_t *b = meshObj->meshData.bones;
		int bNum = 0;
		while (bNum < meshObj->meshData.numBones)
		{
			if (!b->parentName[0])
			{
				b->eData.parent = NULL;
			}
			else
			{
				b->eData.parent = Model_FindObjectBoneByName(meshObj, b->parentName);
			}

			//precompute the inverse
			Model_MatrixInverse(&b->mat, &b->eData.invBaseMat);

			b++;
			bNum++;
		}

		if (meshObj->meshData.vertData)
		{ //don't do anything if it's just a non-mesh object
			int x;

			meshObj->curMatrix = g_identityMatrix;
			Model_CreateTransformedVerts(NULL, meshObj, true, 0);

			Model_CreateFormattedFaces(meshObj);

			//allocate space for tangent/bump calcs
			meshObj->meshData.mid.tangentData = (modelTan_t *)rcmalloc(sizeof(modelTan_t)*meshObj->meshData.numVerts, 11);

			//cached tri plane equations
			meshObj->meshData.mid.triPlaneEq = (triPlaneEq_t *)rcmalloc(sizeof(triPlaneEq_t)*meshObj->meshData.numFaces, 119);

			if (!meshObj->meshData.vertNormalsStored)
			{ //if the model file didn't have them contained, calculate them now.
				meshObj->meshData.vertNormals = (float *)rcmalloc((sizeof(float)*3)*meshObj->meshData.numVerts, 11);
				Model_GenerateVertexNormals(meshObj->meshData.vertNormals, meshObj->meshData.numVerts, (modelVert_t *)meshObj->meshData.vertData, meshObj->meshData.numFaces, (modelRDMTriFace_t *)meshObj->meshData.faceData);
			}

			meshObj->meshData.mid.lightVectors = (float *)rcmalloc((sizeof(float)*3)*meshObj->meshData.numVerts, 11);
			meshObj->meshData.mid.halfAngleVectors = (float *)rcmalloc((sizeof(float)*3)*meshObj->meshData.numVerts, 11);

			//get neighbor triangle connections for the object
			meshObj->meshData.faceNeighbors = (modelTriNeighbor_t *)rcmalloc(meshObj->meshData.numFaces*sizeof(modelTriNeighbor_t), 11);
			x = 0;
			while (x < meshObj->meshData.numFaces)
			{
				modelTriFaceGLFormat_t *tri;
				modelTriNeighbor_t *neighbors;

				tri = meshObj->meshData.faceDataFormatted+x;
				neighbors = meshObj->meshData.faceNeighbors+x;

				Model_GetTriNeighbors(meshObj, meshObj->meshData.faceDataFormatted, tri, (int *)neighbors);

				x++;
			}
		}
		meshObj = meshObj->next;
	}

	return 1;
}

//load a model
int Model_LoadModel(const char *p, modelFile_t *curFile)
{
	int bufHandle = Model_Precache(p);

	if (bufHandle == -1)
	{
		return 0;
	}

	curFile->fileBuffer = g_modelBin[bufHandle].data;
	curFile->fileLen = g_modelBin[bufHandle].dataLen;

	return Model_LoadModelParse(curFile);
}

#ifndef SERVERONLY
//free attached decals
void Model_DecalsFree(modelMeshObject_t *obj)
{
	modelDecal_t *d = obj->meshData.mid.decals;
	while (d)
	{
		modelDecal_t *nd = d->next;
		rcfree(d);
		d = nd;
	}
	obj->meshData.mid.decals = NULL;
}

//insert a decal
void Model_DecalsInsert(modelMeshObject_t *obj, modelDecal_t *dec)
{
	dec->next = obj->meshData.mid.decals;
	dec->last = NULL;
	if (obj->meshData.mid.decals)
	{
		obj->meshData.mid.decals->last = dec;
	}
	obj->meshData.mid.decals = dec;
}

//remove a decal
void Model_DecalsRemove(modelMeshObject_t *obj, modelDecal_t *dec)
{
	if (dec->last)
	{
		dec->last->next = dec->next;
	}
	else
	{ //if i am the root, assign the root to my next
		obj->meshData.mid.decals = dec->next;
	}
	if (dec->next)
	{
		dec->next->last = dec->last;
	}
	rcfree(dec);
}
#endif //SERVERONLY

//free up per-instance data
void Model_FreePerInstanceData(modelMeshObject_t *rootObj, qboolean freeAsLL)
{
	modelMeshObject_t *obj = rootObj;
	while (obj)
	{
		if (obj->meshData.mid.vertDataTransformed)
		{
			rcfree(obj->meshData.mid.vertDataTransformed);
			obj->meshData.mid.vertDataTransformed = NULL;
		}

		if (obj->meshData.mid.boneOverrides)
		{
			rcfree(obj->meshData.mid.boneOverrides);
			obj->meshData.mid.boneOverrides = NULL;
		}

		if (obj->meshData.mid.shadVolVerts)
		{
			rcfree(obj->meshData.mid.shadVolVerts);
			obj->meshData.mid.shadVolVerts = NULL;
		}
		if (obj->meshData.mid.shadVolTris)
		{
			rcfree(obj->meshData.mid.shadVolTris);
			obj->meshData.mid.shadVolTris = NULL;
		}

		if (obj->meshData.mid.tangentData)
		{
			rcfree(obj->meshData.mid.tangentData);
			obj->meshData.mid.tangentData = NULL;
		}
		if (obj->meshData.mid.triPlaneEq)
		{
			rcfree(obj->meshData.mid.triPlaneEq);
			obj->meshData.mid.triPlaneEq = NULL;
		}
#ifndef SERVERONLY
		if (obj->meshData.mid.decals)
		{
			Model_DecalsFree(obj);
		}
#endif
		if (obj->meshData.mid.clipTriPlaneEq)
		{
			rcfree(obj->meshData.mid.clipTriPlaneEq);
			obj->meshData.mid.clipTriPlaneEq = NULL;
		}
		if (obj->meshData.mid.vertNormalsTransformed)
		{
			rcfree(obj->meshData.mid.vertNormalsTransformed);
			obj->meshData.mid.vertNormalsTransformed = NULL;
		}
		if (obj->meshData.mid.lightVectors)
		{
			rcfree(obj->meshData.mid.lightVectors);
			obj->meshData.mid.lightVectors = NULL;
		}
		if (obj->meshData.mid.halfAngleVectors)
		{
			rcfree(obj->meshData.mid.halfAngleVectors);
			obj->meshData.mid.halfAngleVectors = NULL;
		}
		if (obj->meshData.mid.colorPointer)
		{
			rcfree(obj->meshData.mid.colorPointer);
			obj->meshData.mid.colorPointer = NULL;
		}
		if (!freeAsLL)
		{
			break;
		}
		obj = obj->next;
	}
}

//free memory for given model
void Model_FreeModel(modelMeshObject_t *rootObj, qboolean freeAsLL)
{
	modelMeshObject_t *obj = rootObj;
	modelMeshObject_t *n;

	Model_FreePerInstanceData(rootObj, freeAsLL);

	while (obj)
	{ //go through each mesh object and free any dynamically allocated storage.
		if (obj->meshData.faceDataFormatted)
		{
			rcfree(obj->meshData.faceDataFormatted);
		}
		if (obj->meshData.faceNeighbors)
		{
			rcfree(obj->meshData.faceNeighbors);
		}
		if (obj->meshData.vertNormals && !obj->meshData.vertNormalsStored)
		{
			rcfree(obj->meshData.vertNormals);
		}
		/*
		if (obj->meshData.tangentDataTransformed)
		{
			rcfree(obj->meshData.tangentDataTransformed);
		}
		*/

		if (!obj->meshData.inheritedBones)
		{ //free memory allocated for bone objects
			rcfree(obj->meshData.bones);
		}

		if (!freeAsLL)
		{ //object itself is not part of a linked list, and should not be freed
			break;
		}

		n = obj->next;
		rcfree(obj);
		obj = n;
	}

	//rcfree(model->fileBuffer);
}

//make sure the model is loaded and that at least one instance is around
void Model_CacheInstance(const char *filename)
{
	int i;

	i = 0;
	while (i < MAX_MODEL_POOL_SIZE)
	{
		if (g_modelPool[i].inuse)
		{
			if (g_modelPool[i].filename &&
				!stricmp(g_modelPool[i].filename, filename))
			{ //reuse it
				return;
			}
		}
		i++;
	}

	//if not found, allocate
	Model_Allocate(filename);
}

//precache a model
int Model_Precache(const char *filename)
{
	int i;
	int nextFree;
	int match = -1;
	FILE *f;
	int bufferLen;

	i = 0;
	while (i < MAX_MODEL_BINSTORAGE_SIZE)
	{
		if (g_modelBin[i].inuse && g_modelBin[i].filename)
		{
			if (!stricmp(g_modelBin[i].filename, filename))
			{
				match = i;
				break;
			}
		}
		i++;
	}

	if (match != -1)
	{
		return match;
	}

	nextFree = -1;

	i = 0;
	while (i < MAX_MODEL_BINSTORAGE_SIZE)
	{
		if (!g_modelBin[i].inuse)
		{
			nextFree = i;
			break;
		}
		i++;
	}

	if (nextFree == -1)
	{ //ran out of space
		assert(!"Ran out of model bin space");
		return -1;
	}

	//now read it in.
	f = NULL;
	bufferLen = COM_FOpenFile((char *)filename, &f);
	if (bufferLen <= 0 || !f)
	{
		return -1;
	}

	g_modelBin[nextFree].data = (BYTE *)rcmalloc(bufferLen, 11);
	g_modelBin[nextFree].dataLen = bufferLen;

	fread(g_modelBin[nextFree].data, bufferLen, 1, f);
	fclose(f);

	g_modelBin[nextFree].filename = (char *)rcmalloc(strlen(filename)+1, 11);
	strcpy(g_modelBin[nextFree].filename, filename);
	g_modelBin[nextFree].inuse = true;

	return nextFree;
}

//copy model objects
void Model_CopyModelObjects(modelFile_t *from, modelFile_t *to)
{
	modelMeshObject_t *obj = from->firstObject;
	modelMeshObject_t **n;
	to->firstObject = NULL;
	n = &to->firstObject;
	while (obj)
	{
		if (!*n)
		{
			*n = (modelMeshObject_t *)rcmalloc(sizeof(modelMeshObject_t), 11);
		}
		memcpy(*n, obj, sizeof(modelMeshObject_t));
		memset(&(*n)->meshData.mid, 0, sizeof(modelInstanceData_t));

		Model_CreateTransformedVerts(NULL, *n, true, 0);
		//allocate space for tangent/bump calcs
		(*n)->meshData.mid.tangentData = (modelTan_t *)rcmalloc(sizeof(modelTan_t)*(*n)->meshData.numVerts, 11);
		(*n)->meshData.mid.triPlaneEq = (triPlaneEq_t *)rcmalloc(sizeof(triPlaneEq_t)*(*n)->meshData.numFaces, 119);
		(*n)->meshData.mid.lightVectors = (float *)rcmalloc((sizeof(float)*3)*(*n)->meshData.numVerts, 11);
		(*n)->meshData.mid.halfAngleVectors = (float *)rcmalloc((sizeof(float)*3)*(*n)->meshData.numVerts, 11);

		n = &(*n)->next;
		*n = NULL;
		obj = obj->next;
	}
}

//allocate a model from the pool
safeModelPtr_t *Model_Allocate(const char *filename)
{
	int i;
	int nextFree = -1;
	int existingInstance = -1;
	char animName[2048];

	i = 0;
	while (i < MAX_MODEL_POOL_SIZE)
	{
		if (!g_modelPool[i].inuse)
		{
			if (nextFree == -1)
			{
				nextFree = i;
			}
		}
		else if (existingInstance == -1)
		{
			if (g_modelPool[i].deferredFrom == -1 &&
				g_modelPool[i].filename &&
				!stricmp(g_modelPool[i].filename, filename))
			{ //we'll use most of the calculated stuff out of here
				existingInstance = i;
			}
		}
		i++;
	}

	if (nextFree == -1)
	{
		assert(!"Out of models!");
		return NULL;
	}

	g_modelPool[nextFree].model = (modelFile_t *)rcmalloc(sizeof(modelFile_t), 811);
	memset(g_modelPool[nextFree].model, 0, sizeof(modelFile_t));

	if (existingInstance == -1)
	{ //create a new one
		if (!Model_LoadModel(filename, g_modelPool[nextFree].model))
		{
			assert(!"Failed to parse model!!!");
			rcfree(g_modelPool[nextFree].model);
			return NULL;
		}

		g_modelPool[nextFree].inuse = true;
		g_modelPool[nextFree].filename = (char *)rcmalloc(strlen(filename)+1, 911);
		strcpy(g_modelPool[nextFree].filename, filename);
		g_modelPool[nextFree].deferredFrom = -1;

		assert(g_modelSafePtrs[nextFree].userCount == 0);
		g_modelSafePtrs[nextFree].userCount++;
	}
	else
	{ //copy what we can from an existing one
		g_modelPool[nextFree].inuse = true;
		g_modelPool[nextFree].filename = g_modelPool[existingInstance].filename;
		g_modelPool[nextFree].deferredFrom = existingInstance;
		memcpy(g_modelPool[nextFree].model, g_modelPool[existingInstance].model, sizeof(modelFile_t));
		Model_CopyModelObjects(g_modelPool[existingInstance].model, g_modelPool[nextFree].model);

		g_modelSafePtrs[existingInstance].userCount++;
	}

	//set up the "safe pointer"
	g_modelSafePtrs[nextFree].allocated = true;
	g_modelSafePtrs[nextFree].explicitlyFreed = false;
	g_modelSafePtrs[nextFree].index = nextFree;
	strcpy(g_modelSafePtrs[nextFree].fileName, filename);
	g_modelSafePtrs[nextFree].p = g_modelPool[nextFree].model;

	//try getting an anim of the same base name
	strcpy(animName, filename);
	if (strlen(animName) > 4 && !stricmp(&animName[strlen(animName)-4], ".rdm"))
	{
		animName[strlen(animName)-4] = 0;
	}
	strcat(animName, ".rda");
	g_modelPool[nextFree].model->baseAnim = Anim_Allocate(animName);

	return &g_modelSafePtrs[nextFree];
}

//free only objects in model
void Model_FreeOnlyObjects(modelFile_t *model)
{
	modelMeshObject_t *obj = model->firstObject;
	while (obj)
	{
		modelMeshObject_t *n = obj->next;
		rcfree(obj);
		obj = n;
	}
}

//free a model from the pool
void Model_Free(int index)
{
	if (!g_modelSafePtrs[index].allocated)
	{ //already free!
		return;
	}

#ifndef SERVERONLY
	if (g_modelPool[index].model && g_modelPool[index].model->lodHack &&
		g_modelPool[index].model->lodModel)
	{ //free the lod instance first
		Model_Free(g_modelPool[index].model->lodModel->index);
		g_modelPool[index].model->lodModel = NULL;
	}
#endif

	if (g_modelPool[index].deferredFrom == -1)
	{ //i'm an original
		g_modelSafePtrs[index].userCount--;
		if (g_modelSafePtrs[index].userCount > 0)
		{ //someone somewhere is still actually using this one.
			return;
		}
	}
	else
	{ //if deferred from another, try to free it now that i'm going away
		Model_FreePerInstanceData(g_modelPool[index].model->firstObject, true);
		Model_FreeOnlyObjects(g_modelPool[index].model);
		rcfree(g_modelPool[index].model);
		Model_Free(g_modelPool[index].deferredFrom);
		g_modelPool[index].inuse = false;
		g_modelSafePtrs[index].allocated = false;
		return;
	}

	assert(g_modelPool[index].model &&
		g_modelPool[index].inuse);

	Model_FreeModel(g_modelPool[index].model->firstObject, true);
	rcfree(g_modelPool[index].model);
	rcfree(g_modelPool[index].filename);
	g_modelPool[index].inuse = false;
	g_modelSafePtrs[index].allocated = false;
	g_modelSafePtrs[index].explicitlyFreed = true;
}

//destroy everything. dangerous for lingering model pointers!
void Model_ClearPool(qboolean setExplicit)
{
	int i;

	i = 0;
	while (i < MAX_MODEL_POOL_SIZE)
	{
		g_modelSafePtrs[i].explicitlyFreed = setExplicit;
		if (g_modelPool[i].inuse)
		{
			assert(g_modelPool[i].model && g_modelPool[i].filename);

			Model_Free(i);
		}
		i++;
	}

	i = 0;
	while (i < MAX_MODEL_BINSTORAGE_SIZE)
	{
		if (g_modelBin[i].inuse)
		{
			assert(g_modelBin[i].data && g_modelBin[i].filename);

			rcfree(g_modelBin[i].data);
			rcfree(g_modelBin[i].filename);
			g_modelBin[i].inuse = false;
		}
		i++;
	}

#ifndef SERVERONLY
	memset(g_edictModels, 0, sizeof(g_edictModels));
#endif
}

//get pointers to vital model data
void Model_GetModelInfo(safeModelPtr_t *model, int *numVerts, int *numFaces,
						float **vertData, int **triData)
{
	if (!model || !SafeModelPtr_GetModel(model) || !SafeModelPtr_GetModel(model)->firstObject)
	{
		return;
	}

	*numVerts = SafeModelPtr_GetModel(model)->firstObject->meshData.numVerts;
	*numFaces = SafeModelPtr_GetModel(model)->firstObject->meshData.numFaces;

	*vertData = (float *)SafeModelPtr_GetModel(model)->firstObject->meshData.vertData;
	*triData = (int *)SafeModelPtr_GetModel(model)->firstObject->meshData.faceDataFormatted;
}

//get pointers to vital model data (caller responsible for freeing data)
void Model_GetModelInfoMultiObj(safeModelPtr_t *model, int *numVerts, int *numFaces,
						float **vertData, int **triData)
{
	float *lVertData = NULL;
	int *lTriData = NULL;
	modelMeshObject_t *root;

	if (!model || !SafeModelPtr_GetModel(model) || !SafeModelPtr_GetModel(model)->firstObject)
	{
		return;
	}

	*numVerts = 0;
	*numFaces = 0;
	root = SafeModelPtr_GetModel(model)->firstObject;
	while (root)
	{
		int i;
		float *entryVert;
		int *entryTri;

		(*numVerts) += root->meshData.numVerts;
		(*numFaces) += root->meshData.numFaces;
		if (!lVertData)
		{
			lVertData = (float *)malloc((sizeof(float)*3)*(*numVerts));
			lTriData = (int *)malloc((sizeof(int)*3)*(*numFaces));
		}
		else
		{
			lVertData = (float *)realloc(lVertData, (sizeof(float)*3)*(*numVerts));
			lTriData = (int *)realloc(lTriData, (sizeof(int)*3)*(*numFaces));
		}

		entryVert = lVertData+(3*((*numVerts)-root->meshData.numVerts));
		entryTri = lTriData+(3*((*numFaces)-root->meshData.numFaces));

		memcpy(entryVert, root->meshData.vertData, (sizeof(float)*3)*root->meshData.numVerts);
		memcpy(entryTri, root->meshData.faceDataFormatted, (sizeof(int)*3)*root->meshData.numFaces);

		i = 0;
		while (i < root->meshData.numFaces)
		{ //vert indexes need to be adjusted
			entryTri[0] += (*numVerts)-root->meshData.numVerts;
			entryTri[1] += (*numVerts)-root->meshData.numVerts;
			entryTri[2] += (*numVerts)-root->meshData.numVerts;

			entryTri += 3;

			i++;
		}

		root = root->next;
	}

	*vertData = lVertData;
	*triData = lTriData;
}

//wrapper class, for safe access in case a model is removed (by a video mode change or whatever)
//this is one of the few instances where you will catch me actually making use of c++.
modelFile_t *SafeModelPtr_GetModel(safeModelPtr_t *safe)
{
	if (!safe->allocated)
	{ //it got freed! so..
		assert(!safe->explicitlyFreed); //hmm, this would be a legitimate bad access.

		g_modelPool[safe->index].model = (modelFile_t *)rcmalloc(sizeof(modelFile_t), 11);
		memset(g_modelPool[safe->index].model, 0, sizeof(modelFile_t));

		if (!Model_LoadModel(safe->fileName, g_modelPool[safe->index].model))
		{
			assert(!"Failed to parse model!!!");
			rcfree(g_modelPool[safe->index].model);
			return NULL;
		}

		g_modelPool[safe->index].inuse = true;
		g_modelPool[safe->index].filename = (char *)rcmalloc(strlen(safe->fileName)+1, 11);
		strcpy(g_modelPool[safe->index].filename, safe->fileName);

		safe->allocated = true;
		safe->p = g_modelPool[safe->index].model;
	}
	return safe->p;
}

//load the mesh into the quake model structure
void Model_LoadRDMForQuake(model_t *mod, unsigned char *buf)
{
	modelFile_t *model;
	Model_CacheInstance(mod->name);
	mod->type = mod_rdm;
	mod->rdm = Model_Allocate(mod->name);
	model = SafeModelPtr_GetModel(mod->rdm);
	if (model && model->firstObject)
	{
		int i;
		float largestAxis = 0.0f;
		for (i = 0; i < 3; i++)
		{
			if (model->firstObject->maxs[i] > largestAxis)
			{
				largestAxis = model->firstObject->maxs[i];
			}
			if ((-model->firstObject->mins[i]) > largestAxis)
			{
				largestAxis = (-model->firstObject->mins[i]);
			}
		}
		mod->radius = (largestAxis*1.1f); //just fudge for transforms
		VectorCopy(model->firstObject->mins, mod->mins);
		VectorCopy(model->firstObject->maxs, mod->maxs);
	}
}

#ifndef SERVERONLY
//get the model object from the quake ent
modelFile_t *Model_CoreFromQuakeEnt(entity_t *ent)
{
	modelFile_t *model = NULL;
	model_t *mod = ent->model;
	if (!mod || mod->type != mod_rdm || !mod->rdm)
	{
		return NULL;
	}

	if (ent->gameentnum >= 0 && ent->gameentnum < MAX_EDICTS)
	{
		safeModelPtr_t *p = g_edictModels[ent->gameentnum].model;
		if (!p)
		{ //create a special instance for this ent
			memset(&g_edictModels[ent->gameentnum], 0, sizeof(edictModel_t));
			g_edictModels[ent->gameentnum].model = Model_Allocate(mod->rdm->fileName);
			p = g_edictModels[ent->gameentnum].model;
		}
		if (p)
		{
			if (stricmp(p->fileName, mod->rdm->fileName))
			{ //doesn't match, re-allocate
				Model_Free(g_edictModels[ent->gameentnum].model->index);
				memset(&g_edictModels[ent->gameentnum], 0, sizeof(edictModel_t));
				p = g_edictModels[ent->gameentnum].model = Model_Allocate(mod->rdm->fileName);
			}

			model = SafeModelPtr_GetModel(g_edictModels[ent->gameentnum].model);
		}
	}

	if (ent->rdmInst && !model)
	{ //prefer the specifically instanced model
		model = SafeModelPtr_GetModel(ent->rdmInst);
	}
	if (!model)
	{
		model = SafeModelPtr_GetModel(mod->rdm);
	}
	return model;
}

//draw the mesh object
void Model_DrawRDMMesh(entity_t *ent, modelFile_t *model, modelMeshObject_t *mesh, modelMeshObject_t *lodMesh, dlight_t *dlight, float baseScale)
{
	int tex = mesh->objTexture;
	int normalTex = mesh->objTextureNormal;
	modelParmData_t parm;
	modelMeshObject_t *useMesh = lodMesh ? lodMesh : mesh;

	if (g_bloomin && !useMesh->bloom)
	{ //don't draw on bloom pass
		return;
	}
	
	memset(&parm, 0, sizeof(parm));
	parm.modelScale[0] = baseScale;
	parm.modelScale[1] = baseScale;
	parm.modelScale[2] = baseScale;
	parm.anim = model->baseAnim;
	if (parm.anim && ent->gameentnum >= 0 && ent->gameentnum < MAX_EDICTS)
	{
		edictModel_t *em = &g_edictModels[ent->gameentnum];
		parm.frame = ent->frame;
		parm.oldFrame = ent->frame;
		if (!em->lerpAnimTime)
		{
			em->frame = ent->frame;
			em->oldFrame = ent->frame;
			parm.frameLerp = 0.0f;
			em->lerpAnimTime = realtime;
		}
		else
		{
			double dif;
			double lerpDuration = 0.1; //on-server update interval

			if (em->frame != ent->frame)
			{
				em->oldFrame = em->frame;
				em->frame = ent->frame;
				em->lerpAnimTime = realtime;
			}

			parm.oldFrame = em->oldFrame;

			dif = realtime-em->lerpAnimTime;
			if (dif > lerpDuration)
			{
				dif = lerpDuration;
			}

			parm.frameLerp = 1.0f-(dif/lerpDuration);
		}
	}

	if (!normalTex && dlight)
	{
		normalTex = normalmap_default;
	}

	if (!useMesh->transparent && g_canUseTexFP && gl_normalMaps.value && normalTex > 0 && !g_depthPass)
	{
		float shadelight = 1.0f; //fixme
		float mins[3], maxs[3];
		float *normals;

		Model_CreateTransformedVerts(&parm, useMesh, true, realtime);

#if 0
		VectorAdd(ent->origin, useMesh->meshData.mid.transObjMins, mins);
		VectorAdd(ent->origin, useMesh->meshData.mid.transObjMaxs, maxs);
		if (R_CullBox(mins, maxs))
		{
			return;
		}
#endif

		glEnable(GL_TEXTURE_2D);
		GL_Bind(tex);

		if (useMesh->meshData.mid.vertNormalsTransformed)
		{
			normals = useMesh->meshData.mid.vertNormalsTransformed;
		}
		else
		{
			normals = useMesh->meshData.vertNormals;
		}

		if (!useMesh->meshData.mid.tangentDataCalculated ||
			(useMesh->meshData.mid.tangentDataCalculatedTime != realtime && !model->lodHack))
		{ //lodHack will only create tangents once
			GL_CreateTangentMatrices(useMesh->meshData.numVerts, useMesh->meshData.mid.vertDataTransformed,
				useMesh->meshData.numFaces, (modelTriFace_t *)useMesh->meshData.faceDataFormatted,
				useMesh->meshData.mid.tangentData, (modelTexCoord_t *)(useMesh->meshData.uvCoord+sizeof(WORD)),
				normals);

			useMesh->meshData.mid.tangentDataCalculated = true;
			useMesh->meshData.mid.tangentDataCalculatedTime = realtime;
		}

		GL_CalcModelLightVectors(useMesh->meshData.numVerts, useMesh->meshData.mid.tangentData,
			(float *)useMesh->meshData.mid.vertDataTransformed, useMesh->meshData.mid.lightVectors,
			normals, dlight, ent, 0, false);

		if (!dlight)
		{ //bind the standard lighting program
			g_glExt.glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB, g_fpLightRDMAmbientH);
			glEnable(GL_FRAGMENT_PROGRAM_ARB);

			glColor4f(shadelight, shadelight, shadelight, 1.0f);
		}

		glEnableClientState(GL_VERTEX_ARRAY);
		glVertexPointer(3, GL_FLOAT, 3 * sizeof(GL_FLOAT), useMesh->meshData.mid.vertDataTransformed);
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);			
		glTexCoordPointer(2, GL_FLOAT, 2 * sizeof(GL_FLOAT), useMesh->meshData.uvCoord+sizeof(WORD));

		//set up the normal map texture
		g_glExt.glActiveTextureARB(GL_TEXTURE1_ARB);
		g_glExt.glClientActiveTextureARB(GL_TEXTURE1_ARB);
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, normalTex);
		//stick the light vectors in the tc for this unit, since we can just use normal tc for the nmap
		glTexCoordPointer(3, GL_FLOAT, 3 * sizeof(GL_FLOAT), useMesh->meshData.mid.lightVectors);
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);

		if (useMesh->alphaMask)
		{
			glEnable(GL_ALPHA_TEST);
		}

		glDrawElements(GL_TRIANGLES, useMesh->meshData.numFaces*3, GL_UNSIGNED_INT, useMesh->meshData.faceDataFormatted);

		if (useMesh->alphaMask)
		{
			glDisable(GL_ALPHA_TEST);
		}

		glDisable(GL_TEXTURE_2D); //disable 2d on texture1
		glDisableClientState(GL_TEXTURE_COORD_ARRAY); //disable tc array on texture1

		g_glExt.glActiveTextureARB(GL_TEXTURE0_ARB);
		g_glExt.glClientActiveTextureARB(GL_TEXTURE0_ARB);

		if (!dlight)
		{
			glDisable(GL_FRAGMENT_PROGRAM_ARB);
		}

		glDisableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	}
	else if (!dlight)
	{
		float mins[3], maxs[3];
		Model_CreateTransformedVerts(&parm, useMesh, true, realtime);

#if 0
		VectorAdd(ent->origin, useMesh->meshData.mid.transObjMins, mins);
		VectorAdd(ent->origin, useMesh->meshData.mid.transObjMaxs, maxs);
		if (R_CullBox(mins, maxs))
		{
			return;
		}
#endif

		if (!g_depthPass)
		{
			if (useMesh->transparent)
			{ //todo - allow custom blend modes/colors. ideally a texture shader system, but too lazy to port mine
				glEnable(GL_BLEND);
				glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);
				glColor4f(0.5f, 0.5f, 0.5f, 1.0f);
			}
			else
			{
				float clr[4];
				clr[0] = ((float)R_LightPoint(ent->origin) / 255.0f) * 0.25f;
				if (!clr[0])
				{ //don't allow pitch-black
					clr[0] = 0.25f;
				}
				clr[1] = clr[2] = clr[0];
				clr[3] = 1.0f;
				glColor4fv(clr);
			}
			glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		}

		if (useMesh->alphaMask)
		{
			glEnable(GL_ALPHA_TEST);
		}

		GL_Bind(tex);

		glEnableClientState(GL_VERTEX_ARRAY);
		glVertexPointer(3, GL_FLOAT, 3 * sizeof(GL_FLOAT), useMesh->meshData.mid.vertDataTransformed);
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);			
		glTexCoordPointer(2, GL_FLOAT, 2 * sizeof(GL_FLOAT), useMesh->meshData.uvCoord+sizeof(WORD));

		glDrawElements(GL_TRIANGLES, useMesh->meshData.numFaces*3, GL_UNSIGNED_INT, useMesh->meshData.faceDataFormatted);

		glDisableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);

		if (useMesh->alphaMask)
		{
			glDisable(GL_ALPHA_TEST);
		}

		if (!g_depthPass)
		{
			glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
			glColor4f(1.0f, 1.0f, 1.0f, 1.0f);

			if (useMesh->transparent)
			{
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
				glDisable(GL_BLEND);
			}
		}
	}
}

//gl draw a model from a quake render entity
void Model_DrawRDMModel(entity_t *ent, int lightNum)
{
	modelFile_t *model;
	modelMeshObject_t *mesh;
	dlight_t *dlight = NULL;
	qboolean transparency = false;
	qboolean lodHack;
	modelFile_t *lodModel = NULL;
	modelMeshObject_t *lodMesh = NULL;

	model = Model_CoreFromQuakeEnt(ent);
	if (!model)
	{
		return;
	}

	lodHack = (model->lodHack && model->lodModel && (model->lodDist > g_lodHackDist || !gl_qualityFoliage.value));
	if (lodHack)
	{
		lodModel = SafeModelPtr_GetModel(model->lodModel);
		if (!lodModel)
		{
			lodHack = false;
		}
	}


	if (ent->cullFrame != r_framecount)
	{
		float mins[3], maxs[3];
		float baseScale = model->baseScale;
		if (!baseScale)
		{
			baseScale = 1.0f;
		}
		mins[0] = ent->origin[0]-(ent->model->radius*baseScale);
		mins[1] = ent->origin[1]-(ent->model->radius*baseScale);
		mins[2] = ent->origin[2]-(ent->model->radius*baseScale);
		maxs[0] = ent->origin[0]+(ent->model->radius*baseScale);
		maxs[1] = ent->origin[1]+(ent->model->radius*baseScale);
		maxs[2] = ent->origin[2]+(ent->model->radius*baseScale);

		ent->culled = R_CullBox(mins, maxs);
		ent->cullFrame = r_framecount;
	}

	/*
	{
		float mins[3], maxs[3];
		float baseScale = model->baseScale;
		if (!baseScale)
		{
			baseScale = 1.0f;
		}
		mins[0] = ent->origin[0]-(ent->model->radius*baseScale);
		mins[1] = ent->origin[1]-(ent->model->radius*baseScale);
		mins[2] = ent->origin[2]-(ent->model->radius*baseScale);
		maxs[0] = ent->origin[0]+(ent->model->radius*baseScale);
		maxs[1] = ent->origin[1]+(ent->model->radius*baseScale);
		maxs[2] = ent->origin[2]+(ent->model->radius*baseScale);
		GL_DebugDrawLineMinsMaxs(mins, maxs, NULL);
	}
	*/

	if (ent->culled)
	{
		return;
	}

	if (lightNum >= 0)
	{
		dlight = &cl_dlights[lightNum];
	}

	//i don't use quake's backward faces
	glCullFace(GL_BACK);

	glShadeModel(GL_SMOOTH);

	glPushMatrix();
	R_RotateForEntity(ent);

	if (lodHack)
	{
		lodMesh = lodModel->firstObject;
	}
	for (mesh = model->firstObject; mesh; mesh = mesh->next)
	{
		if (mesh->transparent || mesh->alphaMask)
		{ //draw the transparent ones later
			if (lodMesh)
			{
				lodMesh = lodMesh->next;
			}
			transparency = true;
			continue;
		}
		Model_DrawRDMMesh(ent, model, mesh, lodMesh, dlight, model->baseScale);
		if (lodMesh)
		{
			lodMesh = lodMesh->next;
		}
	}
	if (transparency)
	{
		if (lodHack)
		{
			lodMesh = lodModel->firstObject;
		}
		for (mesh = model->firstObject; mesh; mesh = mesh->next)
		{
			if (!mesh->transparent && !mesh->alphaMask)
			{
				if (lodMesh)
				{
					lodMesh = lodMesh->next;
				}
				continue;
			}
			if (mesh->transparent && dlight)
			{ //don't draw blended things on the dlight pass
				if (lodMesh)
				{
					lodMesh = lodMesh->next;
				}
				continue;
			}
			Model_DrawRDMMesh(ent, model, mesh, lodMesh, dlight, model->baseScale);
			if (lodMesh)
			{
				lodMesh = lodMesh->next;
			}
		}
	}

	glPopMatrix();

	glShadeModel(GL_FLAT);

	glCullFace(GL_FRONT);
}

//draw the shadow volume for the model from the quake entity
void GL_DrawRDMVolume(entity_t *ent, int lightNum)
{
	modelFile_t *model;
	modelMeshObject_t *mesh;
	float volMins[3], volMaxs[3];
	int checkVerts, checkTris;
	int i;
	dlight_t *dlight = NULL;
	const float fudge = 1.0f;
	qboolean inLight = true;
	qboolean lodHack;
	modelFile_t *lodModel = NULL;
	modelMeshObject_t *lodMesh = NULL;

	model = Model_CoreFromQuakeEnt(ent);
	if (!model || !model->firstObject)
	{
		return;
	}

	if (model->noShadows)
	{
		return;
	}

	lodHack = false;//(model->lodHack && model->lodModel && model->lodDist > g_lodHackDist);
	if (lodHack)
	{
		lodModel = SafeModelPtr_GetModel(model->lodModel);
		if (!lodModel)
		{
			lodHack = false;
		}
	}

	if (lodHack)
	{
		return;
	}

	if (lightNum >= 0)
	{
		dlight = &cl_dlights[lightNum];
	}

	if (dlight)
	{
		float mins[3], maxs[3];
		float baseScale = model->baseScale;
		if (!baseScale)
		{
			baseScale = 1.0f;
		}
		mins[0] = ent->origin[0]-(ent->model->radius*baseScale);
		mins[1] = ent->origin[1]-(ent->model->radius*baseScale);
		mins[2] = ent->origin[2]-(ent->model->radius*baseScale);
		maxs[0] = ent->origin[0]+(ent->model->radius*baseScale);
		maxs[1] = ent->origin[1]+(ent->model->radius*baseScale);
		maxs[2] = ent->origin[2]+(ent->model->radius*baseScale);

		for (i = 0; i < 3; i++)
		{
			if (dlight->origin[i]-fudge > maxs[i])
			{
				inLight = false;
				break;
			}
			if (dlight->origin[i]+fudge < mins[i])
			{
				inLight = false;
				break;
			}
		}
	}
	else
	{
		inLight = false;
	}

    glPushMatrix();
	R_RotateForEntity(ent);

	if (lodHack)
	{
		lodMesh = lodModel->firstObject;
	}
	for (mesh = model->firstObject; mesh; mesh = mesh->next)
	{
		float *useVerts;
		int *useTris;
		float *useMins, *useMaxs;
		modelMeshObject_t *useMesh = lodMesh ? lodMesh : mesh;

		if (useMesh->transparent || useMesh->bloom)
		{ //don't bother drawing shadows for transparent/bloomy things
			if (lodMesh)
			{
				lodMesh = lodMesh->next;
			}
			continue;
		}

		if (useMesh->meshData.mid.shadVolVerts && useMesh->meshData.mid.shadVolTris &&
			useMesh->meshData.mid.shadowVolScale == useMesh->meshData.mid.vertDataLastScale[0])
		{ //use cached volume
			checkVerts = useMesh->meshData.mid.numShadVolVerts;
			checkTris = useMesh->meshData.mid.numShadVolTris;
			useVerts = useMesh->meshData.mid.shadVolVerts;
			useTris = useMesh->meshData.mid.shadVolTris;
			useMins = useMesh->meshData.mid.shadowVolMins;
			useMaxs = useMesh->meshData.mid.shadowVolMaxs;
		}
		else
		{
			float baseScale = model->baseScale;
			if (!baseScale)
			{
				baseScale = 1.0f;
			}

			checkVerts = 0;
			checkTris = 0;
			volMins[0] = useMesh->meshData.mid.vertDataTransformed[0].x-0.01f;
			volMins[1] = useMesh->meshData.mid.vertDataTransformed[0].y-0.01f;
			volMins[2] = useMesh->meshData.mid.vertDataTransformed[0].z-0.01f;
			volMaxs[0] = useMesh->meshData.mid.vertDataTransformed[0].x+0.01f;
			volMaxs[1] = useMesh->meshData.mid.vertDataTransformed[0].y+0.01f;
			volMaxs[2] = useMesh->meshData.mid.vertDataTransformed[0].z+0.01f;

			GL_GenerateShadowVolume((ent->model->radius*baseScale)*1.5f, dlight, inLight, &checkVerts, &checkTris,
				useMesh->meshData.numVerts, useMesh->meshData.numFaces, (float *)useMesh->meshData.mid.vertDataTransformed,
				(int *)useMesh->meshData.faceDataFormatted, useMesh->meshData.faceNeighbors, (modelVert_t *)volVerts,
				volTris, volMins, volMaxs);
			useVerts = volVerts;
			useTris = volTris;
			useMins = volMins;
			useMaxs = volMaxs;
			//todo - find ideal circumstances to make use of this
			/*
			if (checkVerts > 0 && checkTris > 0)
			{ //create a cache
				size_t s;

				if (useMesh->meshData.mid.shadVolVerts)
				{
					rcfree(useMesh->meshData.mid.shadVolVerts);
					useMesh->meshData.mid.shadVolVerts = NULL;
				}
				if (useMesh->meshData.mid.shadVolTris)
				{
					rcfree(useMesh->meshData.mid.shadVolTris);
					useMesh->meshData.mid.shadVolTris = NULL;
				}
				
				s = (sizeof(float)*3)*checkVerts;
				useMesh->meshData.mid.numShadVolVerts = checkVerts;
				useMesh->meshData.mid.shadVolVerts = (float *)rcmalloc(s, 99);
				memcpy(useMesh->meshData.mid.shadVolVerts, volVerts, s);

				s = (sizeof(int)*3)*checkTris;
				useMesh->meshData.mid.numShadVolTris = checkTris;
				useMesh->meshData.mid.shadVolTris = (int *)rcmalloc(s, 99);
				memcpy(useMesh->meshData.mid.shadVolTris, volTris, s);

				VectorCopy(volMins, useMesh->meshData.mid.shadowVolMins);
				VectorCopy(volMaxs, useMesh->meshData.mid.shadowVolMaxs);

				useMesh->meshData.mid.shadowVolScale = useMesh->meshData.mid.vertDataLastScale[0];
			}
			*/
		}
		if (checkVerts > 0 && checkTris > 0)
		{
			VectorAdd(ent->origin, useMins, volMins);
			VectorAdd(ent->origin, useMaxs, volMaxs);

			if (!R_CullBox(volMins, volMaxs))
			{ //no need to draw it if it's culled from view
				glEnableClientState(GL_VERTEX_ARRAY);
				glVertexPointer(3, GL_FLOAT, 3 * sizeof(GL_FLOAT), useVerts);
				glDrawElements(GL_TRIANGLES, checkTris*3, GL_UNSIGNED_INT, useTris);
				glDisableClientState(GL_VERTEX_ARRAY);
			}
		}

		if (lodMesh)
		{
			lodMesh = lodMesh->next;
		}
	}

	glPopMatrix();
}
#endif //SERVERONLY

//====================================
//animation functionality
//====================================

typedef struct animCache_s
{
	char		*filename;
	rda_t		*rda;
	qboolean	inuse;
} animCache_t;
#define ANIMCACHE_MAX_SIZE		256
animCache_t g_animCache[ANIMCACHE_MAX_SIZE];
int g_animCacheUsed = 0;

//add anim to cache
static void Anim_AddToCache(rda_t *rda, const char *filename)
{
	int i = 0;
	while (i < ANIMCACHE_MAX_SIZE)
	{
		if (!g_animCache[i].inuse)
		{
			animCache_t *c = &g_animCache[i];
            c->filename = (char *)rcmalloc(strlen(filename)+1, 69);
			strcpy(c->filename, filename);
			c->rda = rda;
			c->inuse = true;

			if (i >= g_animCacheUsed)
			{
				g_animCacheUsed = i+1;
			}
			break;
		}
		i++;
	}
}

//allocate an animation
rda_t *Anim_Allocate(const char *filename)
{
	FILE *f;
	int len;
	int i = 0;
	BYTE *rdaBuffer;
	rda_t *src;
	rda_t *rda;
	BYTE *srcBoneOffset;
	int boneChunkSize;
	while (i < g_animCacheUsed)
	{
		if (g_animCache[i].inuse && !stricmp(g_animCache[i].filename, filename))
		{
			return g_animCache[i].rda;
		}
		i++;
	}

	f = NULL;
	len = COM_FOpenFile((char *)filename, &f);
	if (len <= 0 || !f)
	{
		return NULL;
	}

	rdaBuffer = (BYTE *)rcmalloc(len, 69);
	fread(rdaBuffer, len, 1, f);
	fclose(f);

	src = (rda_t *)rdaBuffer;
	rda = (rda_t *)rcmalloc(sizeof(rda_t), 69);
	rda->hdr = src->hdr;
	rda->bones = (rdaBone_t *)rcmalloc(sizeof(rdaBone_t)*rda->hdr.numBones, 69);
	memset(rda->bones, 0, sizeof(rdaBone_t)*rda->hdr.numBones);

	srcBoneOffset = (BYTE *)(&src->bones);
	i = 0;
	boneChunkSize = (sizeof(rdaBone_t)-sizeof(modelMatrix_t*))+(sizeof(modelMatrix_t)*rda->hdr.numFrames);
	while (i < rda->hdr.numBones)
	{
		int j;
		modelMatrix_t *srcMats;
		rdaBone_t *bone = rda->bones+i;
		rdaBone_t *srcBone = (rdaBone_t *)(srcBoneOffset+(boneChunkSize*i));
		bone->index = srcBone->index;
		bone->parentIndex = srcBone->parentIndex;
		bone->mat = (modelMatrix_t *)rcmalloc(sizeof(modelMatrix_t)*rda->hdr.numFrames, 69);

		srcMats = (modelMatrix_t *)&srcBone->mat;
		j = 0;
		while (j < rda->hdr.numFrames)
		{
			modelMatrix_t *m = bone->mat+j;
			modelMatrix_t *srcM = srcMats+j;

			*m = *srcM;
			j++;
		}

		i++;
	}
	rcfree(rdaBuffer);

	Anim_AddToCache(rda, filename);

	return rda;
}

//free anim
static void Anim_Free(rda_t *anim)
{
	if (!anim)
	{
		return;
	}

	if (anim->bones)
	{
		int i = 0;
		while (i < anim->hdr.numBones)
		{
			rdaBone_t *bone = anim->bones+i;
			if (bone->mat)
			{
				rcfree(bone->mat);
			}
			i++;
		}
		rcfree(anim->bones);
	}

	rcfree(anim);
}

//animation resource cleanup
void Anim_ClearPool(void)
{
	int i = 0;
	while (i < ANIMCACHE_MAX_SIZE)
	{
		if (g_animCache[i].inuse)
		{
			rcfree(g_animCache[i].filename);
			Anim_Free(g_animCache[i].rda);
		}
		i++;
	}
	memset(g_animCache, 0, sizeof(g_animCache));
	g_animCacheUsed = 0;
}
